题目:
Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. — It is a matter of security to change such things every now and then, to keep the enemy in the dark. — But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! — I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. — No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! — I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. — Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. Now, the minister of finance, who had been eavesdropping, intervened. — No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. — Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? — In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0
题意:给你一个素数,要求你变为另一个素数,其中每次变换后的数也是素数并且与变换前的数只有一位数字之别,且不能有重复,问最小的变换次数(可能没有)。
此题需要判定素数(可以用素数判定),因为每次只有一位数字之别,因此可以对每一位数字采用广搜的办法。其中,千位不能是0,个位不能是偶数,可对其进行剪枝。
参考代码:
#include <iostream>
#include <cstring>
using namespace std;
struct node {
int prime;
int step;
};
bool flag_prime(int num) {
for (int k = 2;k * k <= num;++k) {
if (num % k == 0) {
return false;
}
}
return true;
}
node que[20000];
int number[20000];
int bfs(int num1,int num2) {
node s;
int f = 0,r = 0;
s.prime = num1;
s.step = 0;
que[r++] = s;
number[num1] = 1;
while (r > f) {
node p;
p = que[f++];
if (p.prime == num2) return p.step;
int ge,shi,bai,qian;
ge = p.prime % 10;
shi = (p.prime / 10) % 10;
bai = (p.prime / 100) % 10;
qian = p.prime / 1000;
int num0;
node q;
for (int i = 1;i <= 9;i+=2) {
num0 = qian * 1000 + bai * 100 + shi * 10 + i;
if (flag_prime(num0) && !number[num0]) {
q.prime = num0;
q.step = p.step + 1;
que[r++] = q;
number[num0] = 1;
}
}
for (int i = 0;i <= 9;i++) {
num0 = qian * 1000 + bai * 100 + i * 10 + ge;
if (flag_prime(num0) && !number[num0]) {
q.prime = num0;
q.step = p.step + 1;
que[r++] = q;
number[num0] = 1;
}
}
for (int i = 0;i <= 9;i++) {
num0 = qian * 1000 + i * 100 + shi * 10 + ge;
if (flag_prime(num0) && !number[num0]) {
q.prime = num0;
q.step = p.step + 1;
que[r++] = q;
number[num0] = 1;
}
}
for (int i = 1;i <= 9;i++) {
num0 = i * 1000 + bai * 100 + shi * 10 + ge;
if (flag_prime(num0) && !number[num0]) {
q.prime = num0;
q.step = p.step + 1;
que[r++] = q;
number[num0] = 1;
}
}
}
return -1;
}
int main() {
int t;
int step;
cin >> t;
int num1,num2;
while (t--) {
memset(number,0,sizeof(number));
cin >> num1 >> num2;
step = bfs(num1,num2);
if (step == -1) {
cout << "Impossible" << endl;
}
else {
cout << step << endl;
}
}
return 0;
}